import { ReactElement } from "react";
export type TActionMenuTooltip = {
    placement?: "top" | "left" | "bottom" | "right";
    title: any;
    color?: string;
};
export type TActionMenuItem = {
    title: string;
    action: string;
    confirmationTitle?: string;
    confirmationType?: TActionMenuConfirmationType;
};
export type TActionMenuSettings = {
    onRenderWrapperClassName?: (record?: Record<string, any>) => string;
    onRenderWrapperStyle?: (record?: Record<string, any>) => Record<string, any>;
    onRenderCellClassName?: (record?: Record<string, any>) => string;
    onRenderCellStyle?: (record?: Record<string, any>) => Record<string, any>;
    onRenderIconClassName?: (record?: Record<string, any>) => string;
    onRenderIconColor?: (record?: Record<string, any>) => string;
    onGetIconUrl?: (record?: Record<string, any>) => string;
    onGetTooltip?: (record?: Record<string, any>) => TActionMenuTooltip | undefined;
    onGetActionName?: (record?: Record<string, any>) => string;
    onValidMenuItem?: (menuItem: TActionMenuItem, record?: Record<string, any>) => boolean;
    menuItems?: TActionMenuItem[];
    recordInAction?: TListRecordInAction;
    context?: Record<string, any>;
    tooltip?: TActionMenuTooltip;
    onClickTag?: (tag: string) => void;
    onClick?: TActionMenuOnClick;
    actionName?: string;
    showTags?: boolean;
    colorName?: boolean;
};
export type TListRecordInAction = {
    doing: boolean;
    record: Record<string, any>;
    actionName: string;
    actionMessage?: string;
    color?: string;
};
export type TActionButton = {
    title: string;
    id: string;
    dataIndex: string;
    key: string;
    width?: number;
    fixed?: "right" | "left";
    className?: string;
    recordInAction?: TListRecordInAction;
    render: (id: string, record: Record<string, any>, rowIndex: number) => ReactElement;
};
export type TActionMenuConfirmationType = "default" | "primary" | "ghost" | "dashed" | "link" | "text" | "danger";
export type TActionMenuOnClick = (record: Record<string, any>, action: string, entity?: Record<string, any>, rowIndex?: number) => void;
export declare const renderActionButton: (menuItems: TActionMenuItem[], onClick: TActionMenuOnClick, entity?: Record<string, any>, settings?: TActionMenuSettings) => TActionButton;
