"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.renderActionButton = void 0;
var react_1 = __importDefault(require("react"));
var lodash_1 = require("lodash");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var primeobjects_ui_web_basic_1 = require("primeobjects-ui-web-basic");
var dropdown_1 = __importDefault(require("./antd/dropdown"));
var popconfirm_1 = __importDefault(require("./antd/popconfirm"));
var menu_1 = __importDefault(require("./antd/menu"));
var renderActionButton = function (menuItems, onClick, entity, settings) {
    var onValidMenuItem = settings === null || settings === void 0 ? void 0 : settings.onValidMenuItem;
    var onClickDiv = function (e) {
        var _a, _b, _c;
        if ((0, primeobjects_helper_util_1.isNonEmptyString)((_a = e.target) === null || _a === void 0 ? void 0 : _a.className) &&
            ((_c = (_b = e.target) === null || _b === void 0 ? void 0 : _b.className) === null || _c === void 0 ? void 0 : _c.indexOf("action-button-wrapper")) >= 0) {
            e.target
                .getElementsByClassName("action-button-dropdown")[0]
                .click();
        }
    };
    return {
        title: "",
        id: "id",
        dataIndex: "id",
        key: "action-button",
        width: 40,
        fixed: "right",
        className: "clickable-cell",
        render: function (id, record, rowIndex) {
            var r = __assign({ id: id }, record);
            var currentMenuItems = (0, lodash_1.without)((0, lodash_1.map)(menuItems, function (menuItem, index) {
                var isValid = !onValidMenuItem ||
                    (onValidMenuItem && onValidMenuItem(menuItem, record));
                return isValid ? (react_1.default.createElement(menu_1.default.Item, { key: "action-button-menu-".concat(index), className: "w-full", onClick: function () {
                        (0, lodash_1.isNil)(menuItem.confirmationTitle) &&
                            onClick(r, menuItem.action, entity, rowIndex);
                    } }, !(0, lodash_1.isNil)(menuItem.confirmationTitle) ? (react_1.default.createElement(popconfirm_1.default, { placement: "left", okType: menuItem.confirmationType, title: menuItem.confirmationTitle, onConfirm: function () {
                        onClick(r, menuItem.action, entity, rowIndex);
                    }, okText: "Yes", cancelText: "No" }, menuItem.title)) : (react_1.default.createElement("span", null, menuItem.title)))) : null;
            }), null);
            var menu = currentMenuItems.length > 0 && (react_1.default.createElement(menu_1.default, null, currentMenuItems));
            var wrapperClassName = (0, lodash_1.isFunction)(settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperClassName)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperClassName(record)
                : "";
            var wrapperStyle = (0, lodash_1.isFunction)(settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperStyle)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperStyle(record)
                : {};
            var cellClassName = (0, lodash_1.isFunction)(settings === null || settings === void 0 ? void 0 : settings.onRenderCellClassName)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderCellClassName(record)
                : "";
            var cellStyle = (0, lodash_1.isFunction)(settings === null || settings === void 0 ? void 0 : settings.onRenderCellStyle)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderCellStyle(record)
                : {};
            var iconClassName = (0, lodash_1.isFunction)(settings === null || settings === void 0 ? void 0 : settings.onRenderIconClassName)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderIconClassName(record)
                : {};
            var iconColor = (0, lodash_1.isFunction)(settings === null || settings === void 0 ? void 0 : settings.onRenderIconColor)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderIconColor(record)
                : "#000000";
            var icon = (settings === null || settings === void 0 ? void 0 : settings.onGetIconUrl)
                ? settings === null || settings === void 0 ? void 0 : settings.onGetIconUrl(record)
                : record.uiDoing
                    ? "/icons/platform/loading.svg"
                    : "/icons/platform/menu-vertical.svg";
            return menu ? (react_1.default.createElement("div", { className: "action-button-wrapper w-full h-full flex justify-center flex-col p-0 ".concat(record.uiDisabled
                    ? "cursor-not-allowed"
                    : "cursor-pointer", " ").concat(cellClassName), style: cellStyle, onClick: onClickDiv },
                react_1.default.createElement(dropdown_1.default, { disabled: record.uiDisabled, trigger: ["click"], overlay: menu, placement: "bottomLeft" },
                    react_1.default.createElement("div", { className: "action-button-dropdown w-full flex justify-center ".concat(wrapperClassName), style: wrapperStyle },
                        react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { id: "action-button-svg list-col-icon-action-button", color: iconColor, src: icon, className: "h-4 w-4 ".concat(record.uiDoing ? "spinner" : "", " ").concat(iconClassName) }))))) : (react_1.default.createElement(react_1.default.Fragment, null));
        }
    };
};
exports.renderActionButton = renderActionButton;
//# sourceMappingURL=action-menu.js.map