"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getNavItem = exports.checkNavRole = exports.NavSectionItem = exports.NavSectionItemButton = void 0;
var react_1 = __importDefault(require("react"));
var svg_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/svg"));
var tooltip_1 = __importDefault(require("../../controls/antd/tooltip"));
var colors_1 = require("primeobjects-helper-util/build/cjs/colors");
var lodash_1 = require("lodash");
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var web_1 = require("primeobjects-helper-util/build/cjs/web");
var NavSectionItemButton = function (props) {
    var onClickItem = props.onClickItem, item = props.item, color = props.color, selected = props.selected, navSize = props.navSize, iconColor = props.iconColor, textStyle = props.textStyle, className = props.className, style = props.style;
    var textClassName = props.textClassName ? props.textClassName : "";
    return (react_1.default.createElement("div", { className: "w-full flex p-3 flex-row rounded cursor-pointer items-center ".concat(selected ? "bg-".concat(color.name, "-400") : "hover:shadow", "  ").concat(navSize == "sm" ? "justify-center" : "", " ").concat(item.className ? item.className : className ? className : ""), style: item.style ? item.style : style ? style : {}, onClick: function () { return onClickItem && onClickItem(item); } }, navSize == "sm" ? (react_1.default.createElement(tooltip_1.default, { title: item.title, color: color["400"], placement: "right" },
        react_1.default.createElement("div", { className: "flex flex-col items-center", style: { width: 28 } },
            react_1.default.createElement(svg_1.default, { size: 28, src: item.icon, color: selected
                    ? colors_1.COLORS.WHITE
                    : item.iconColor
                        ? item.iconColor
                        : iconColor
                            ? iconColor
                            : colors_1.COLORS.BLACK })))) : (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: "flex flex-col items-center", style: { width: 28 }, title: item.title },
            react_1.default.createElement(svg_1.default, { size: 28, src: item.icon, color: selected
                    ? colors_1.COLORS.WHITE
                    : item.iconColor
                        ? item.iconColor
                        : iconColor
                            ? iconColor
                            : colors_1.COLORS.BLACK })),
        react_1.default.createElement("div", { className: "flex pl-3 font-medium leading-none items-center text-base ".concat(selected ? "text-white" : "text-black", " ").concat(textClassName), style: textStyle }, item.title)))));
};
exports.NavSectionItemButton = NavSectionItemButton;
var NavSectionItem = function (props) {
    var item = props.item, wrapperClassName = props.wrapperClassName, wrapperStyle = props.wrapperStyle;
    return (react_1.default.createElement("div", { className: "w-full px-2 py-1 flex flex-row items-center ".concat(item.wrapperClassName
            ? item.wrapperClassName
            : wrapperClassName
                ? wrapperClassName
                : ""), style: item.wrapperStyle
            ? item.wrapperStyle
            : wrapperStyle
                ? wrapperStyle
                : {} },
        react_1.default.createElement(exports.NavSectionItemButton, __assign({}, props))));
};
exports.NavSectionItem = NavSectionItem;
var checkNavRole = function (item, user) {
    var _a;
    return user &&
        item &&
        item.roles &&
        ((_a = item.roles) === null || _a === void 0 ? void 0 : _a.length) > 0 &&
        (0, lodash_1.intersectionWith)(item.roles, user.roles, lodash_1.isEqual).length == 0
        ? false
        : true;
};
exports.checkNavRole = checkNavRole;
var getNavItem = function (navigation, user, allowGuest, mustMatchRouter) {
    var _a;
    var firstItem = undefined;
    var selectedItem = undefined;
    var path = (_a = (0, web_1.getWebLocation)("".concat(window.location))) === null || _a === void 0 ? void 0 : _a.path;
    var pathInfo = path ? path.split("/") : [];
    if ((user || allowGuest) && pathInfo.length > 0) {
        if ((pathInfo === null || pathInfo === void 0 ? void 0 : pathInfo.length) == 4 || (pathInfo === null || pathInfo === void 0 ? void 0 : pathInfo.length) == 3) {
            path = (0, lodash_1.last)(pathInfo);
        }
        (0, lodash_1.each)(navigation, function (nav) {
            if (!selectedItem && (0, exports.checkNavRole)(nav, user)) {
                (0, lodash_1.each)(nav.items, function (item) {
                    if (!firstItem &&
                        item.hidden != true &&
                        (0, exports.checkNavRole)(item, user)) {
                        firstItem = item;
                    }
                    if (!selectedItem &&
                        item.hidden != true &&
                        (0, exports.checkNavRole)(item, user) &&
                        (0, core_1.isNonEmptyString)(item.src) &&
                        (0, lodash_1.last)(item.src.toLowerCase().split("/")) == path) {
                        selectedItem = item;
                    }
                });
            }
        });
    }
    return selectedItem
        ? selectedItem
        : !mustMatchRouter
            ? firstItem
            : undefined;
};
exports.getNavItem = getNavItem;
//# sourceMappingURL=item.js.map