"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteIntroSection = void 0;
var react_1 = __importDefault(require("react"));
var site_submit_email_1 = require("./site-submit-email");
var lodash_1 = require("lodash");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var SiteIntroSection = function (props) {
    var submitEmailSettings = props.submitEmailSettings, title = props.title, subTitle = props.subTitle, titleTag = props.titleTag, bookMeetingSettings = props.bookMeetingSettings;
    var solution = props.solution ? props.solution : (0, primeobjects_helper_ui_1.getSolution)();
    var primaryColorName = (0, primeobjects_helper_ui_1.usePrimaryColorName)(solution);
    var colorName = props.colorName ? props.colorName : primaryColorName;
    return (react_1.default.createElement("div", { className: "text-left" },
        titleTag == "h2" ? (react_1.default.createElement("h2", { className: "text-4xl font-extrabold text-gray-900 md:text-5xl sm:max-w-xl sm:mx-auto text-left lg:mx-0 mb-8 leading-tight", dangerouslySetInnerHTML: { __html: title } })) : (react_1.default.createElement("h1", { className: "text-4xl font-extrabold text-gray-900 md:text-5xl sm:max-w-xl sm:mx-auto text-left lg:mx-0 mb-8 leading-tight", dangerouslySetInnerHTML: { __html: title } })),
        !(0, lodash_1.isNil)(subTitle) && (0, primeobjects_helper_util_1.isNonEmptyString)(subTitle) && (react_1.default.createElement("p", { className: "mt-3 text-lg text-gray-500 sm:mt-5 sm:max-w-xl sm:mx-auto md:mt-5 md:text-xl lg:mx-0", dangerouslySetInnerHTML: { __html: subTitle } })),
        !(0, lodash_1.isNil)(submitEmailSettings) && (react_1.default.createElement("div", { className: "text-left mt-8 sm:max-w-xl sm:mx-auto md:mt-12 lg:mx-0" },
            (0, primeobjects_helper_util_1.isNonEmptyString)(submitEmailSettings === null || submitEmailSettings === void 0 ? void 0 : submitEmailSettings.title) && (react_1.default.createElement("div", { className: "w-full" },
                react_1.default.createElement("p", { className: "inline text-lg font-semibold text-".concat(colorName, "-600") }, submitEmailSettings === null || submitEmailSettings === void 0 ? void 0 : submitEmailSettings.title))),
            react_1.default.createElement("div", { className: "w-full" },
                react_1.default.createElement(site_submit_email_1.SiteSubmitEmailSection, __assign({}, submitEmailSettings, { colorName: colorName, solution: solution }))))),
        !(0, lodash_1.isNil)(bookMeetingSettings) && (react_1.default.createElement("div", { className: "text-left mt-8 sm:max-w-xl sm:mx-auto md:mt-12 lg:mx-0" },
            (0, primeobjects_helper_util_1.isNonEmptyString)(submitEmailSettings === null || submitEmailSettings === void 0 ? void 0 : submitEmailSettings.title) && (react_1.default.createElement("div", { className: "w-full" },
                react_1.default.createElement("p", { className: "inline text-lg font-semibold text-".concat(colorName, "-600") }, bookMeetingSettings === null || bookMeetingSettings === void 0 ? void 0 : bookMeetingSettings.title))),
            react_1.default.createElement("div", { className: "w-full" },
                react_1.default.createElement(site_submit_email_1.SiteSubmitEmailSection, __assign({}, bookMeetingSettings, { colorName: colorName, solution: solution })))))));
};
exports.SiteIntroSection = SiteIntroSection;
exports.default = exports.SiteIntroSection;
//# sourceMappingURL=site-intro.js.map