"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteRecordSection = void 0;
var react_1 = __importDefault(require("react"));
var site_section_1 = __importDefault(require("./site-section"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var site_record_content_1 = __importDefault(require("./site-record-content"));
var site_similar_1 = __importDefault(require("./site-similar"));
var site_tags_1 = __importDefault(require("./site-tags"));
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var lodash_1 = require("lodash");
var util_1 = require("../util");
var SiteSimilarSection = undefined;
var SiteRecordSection = function (props) {
    if (!SiteSimilarSection) {
        console.log("Get global components in /sections/site-record.tsx");
        SiteSimilarSection = (0, util_1.getGlobalComponent)("SiteSimilarSection", site_similar_1.default);
    }
    var solution = props.solution;
    var colorName = (0, primeobjects_helper_ui_1.usePrimaryColorName)(solution);
    var submitEmailSettings = props.submitEmailSettings, record = props.record, tagSectionTitle = props.tagSectionTitle, similarSectionTitle = props.similarSectionTitle, urlTemplate = props.urlTemplate, similarSectionAdditionalData = props.similarSectionAdditionalData, flushCache = props.flushCache, wrapperClassName = props.wrapperClassName, wrapperStyle = props.wrapperStyle;
    var maxTagCount = props.maxTagCount ? props.maxTagCount : 100;
    var tags = (0, lodash_1.isArray)(record.tags) ? record.tags.slice(0, maxTagCount) : [];
    if (!(0, primeobjects_helper_util_1.isNonEmptyString)(record.colorName))
        record.colorName = colorName;
    return (react_1.default.createElement(site_section_1.default, { className: "relative ".concat(wrapperClassName !== null && wrapperClassName !== void 0 ? wrapperClassName : ""), style: wrapperStyle !== null && wrapperStyle !== void 0 ? wrapperStyle : {} },
        react_1.default.createElement("div", { className: "max-w-7xl mx-auto" },
            react_1.default.createElement("div", { className: "flex flex-col lg:flex-row relative w-full" },
                react_1.default.createElement("div", { className: "w-full md:max-w-2xl inline article mx-auto" },
                    react_1.default.createElement(site_record_content_1.default, __assign({}, props.recordContentProps, { solution: solution, titleSize: "h1", titleClassName: "mt-0", disableShorten: true, tags: tags, summary: record.summary, sourceUrl: record.sourceUrl, title: record.title, media: record.media, mediaSize: record.mediaSize, needHeaderPhoto: record.needHeaderPhoto, content: record.content, submitEmailSettings: submitEmailSettings, colorName: colorName, wrapperClassName: "mx-auto w-full overflow-hidden" }))),
                react_1.default.createElement("div", { className: "article w-full flex-1 mt-10 flex flex-col lg:border-l lg:pl-10 lg:ml-10 lg:mt-0 md:max-w-2xl mx-auto" },
                    react_1.default.createElement(site_tags_1.default, { data: tags, disableShorten: true, colorName: colorName, wrapperClassName: "mb-6", tagClassName: "hidden mr-4 mb-4 hover:bg-".concat(colorName, "-100 lg:flex"), tagBorderClassName: "border-gray-100 shadow", titleClassName: "hidden lg:flex", title: tagSectionTitle, titleSize: "h2" }),
                    react_1.default.createElement(SiteSimilarSection, { entityName: record.entityName, solution: solution, flushCache: flushCache, cacheKey: "record-similar", wrapperClassName: "mb-6", feedType: "id", feedValue: record.id, scope: "global-and-organization", globalOrganizationId: record.organizationId, additionalData: similarSectionAdditionalData, urlTemplate: urlTemplate, title: similarSectionTitle, titleSize: "h2" }))))));
};
exports.SiteRecordSection = SiteRecordSection;
exports.default = exports.SiteRecordSection;
//# sourceMappingURL=site-record.js.map