//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import React from "react";
import { PlainModal } from "primeobjects-ui-web-basic/build/cjs/controls/plain-modal";
import { getGlobalComponent } from "../../util";
import { useContextStore } from "primeobjects-ui-web-store";
import { getEntity } from "primeobjects-helper-util";
import { isNil } from "lodash";
var SolutionForm = undefined;
export var SolutionModal = function (props) {
    if (!SolutionForm) {
        console.log("Get global components in /modals/solution-modal.tsx");
        SolutionForm = getGlobalComponent("SolutionForm", props.Form);
    }
    var contextStore = useContextStore();
    var context = JSON.parse(contextStore.data);
    var solution = context.solution;
    var entity = getEntity(solution, "Solution");
    var show = props.show, onClickClose = props.onClickClose, title = props.title;
    return (React.createElement(PlainModal, { title: title !== null && title !== void 0 ? title : "Solution Profile", show: show, onClickClose: onClickClose, width: 700 }, !isNil(SolutionForm) && (React.createElement(SolutionForm, { entity: entity, record: solution }))));
};
export default SolutionModal;
//# sourceMappingURL=solution-modal.js.map