//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import React from "react";
import { isNonEmptyString } from "primeobjects-helper-util/build/cjs/core";
import SiteTitle from "./site-title";
import Tags from "primeobjects-ui-web-basic/build/cjs/controls/tags";
import { usePrimaryColor } from "primeobjects-helper-ui";
export var SiteTagsSection = function (props) {
    var colorName = props.colorName, title = props.title, subTitle = props.subTitle, titleSize = props.titleSize, subTitleSize = props.subTitleSize, data = props.data, tagClassName = props.tagClassName, textClassName = props.textClassName, textStyle = props.textStyle, tagBorderClassName = props.tagBorderClassName, disableShorten = props.disableShorten;
    var wrapperClassName = isNonEmptyString(props.wrapperClassName)
        ? props.wrapperClassName
        : "";
    var tagsClassName = isNonEmptyString(props.tagsClassName)
        ? props.tagsClassName
        : "";
    var titleClassName = isNonEmptyString(props.titleClassName)
        ? props.titleClassName
        : "";
    var subTitleClassName = isNonEmptyString(props.subTitleClassName)
        ? props.subTitleClassName
        : "";
    var primaryColor = usePrimaryColor();
    return data.length > 0 ? (React.createElement("div", { className: "w-full ".concat(wrapperClassName) },
        React.createElement(SiteTitle, { title: title, subTitle: subTitle, titleSize: titleSize, subTitleSize: subTitleSize, titleClassName: "text-left text-".concat(primaryColor.name, "-600 ").concat(titleClassName), subTitleClassName: "text-left ".concat(subTitleClassName) }),
        React.createElement("div", { className: "flex flex-col pt-2 ".concat(tagsClassName) },
            React.createElement(Tags, { data: data, tooltipColorName: colorName, onClick: props.onClick, textStyle: textStyle, textClassName: textClassName, tagClassName: tagClassName, borderClassName: tagBorderClassName, disableShorten: disableShorten })))) : (React.createElement(React.Fragment, null));
};
export default SiteTagsSection;
//# sourceMappingURL=site-tags.js.map